//
//  BatteryAndBeepViewController.m
//  IvrJack.RU01.Demo
//
//  Created by xminnov on 15/4/26.
//  Copyright (c) 2015年 xminnov. All rights reserved.
//

#import "BatteryAndBeepViewController.h"
#import "IvrJackService.h"
#import "AppDelegate.h"

@interface BatteryAndBeepViewController ()

@property IvrJackService *service;

@end

@implementation BatteryAndBeepViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.service = ((AppDelegate *)([UIApplication sharedApplication].delegate)).service;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewWillAppear:(BOOL)animated {
    [self getBatteryBuzzerStatus];
}

- (void)viewWillDisappear:(BOOL)animated {
    
}

- (void)getBatteryBuzzerStatus {
    // 操作不能冲突
    if (self.idcDetecting.isAnimating) return;
    
    [self updateUI:YES];
    self.lblStatus.text = @"Reading...";
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_BACKGROUND, 0), ^{
        __block UInt8 battery;
        __block UInt8 buzzer;
        __block int ret = [self.service getBatteryBuzzerStatus:&battery buzzer:&buzzer];
        dispatch_async(dispatch_get_main_queue(), ^{
            [self updateUI:NO];
            if (ret == STATUS_SUCCESS) {
                self.lblStatus.text = @"Success";
                self.lblBattery.text = [NSString stringWithFormat:@"Battery: %02d%%", battery];
                [self.switchBeep setOn:buzzer];
            } else {
                self.lblStatus.text = [NSString stringWithFormat:@"Failed: %d", ret];
            }
        });
        [NSThread sleepForTimeInterval:0.5];
        NSData *version;
        __block int ret2 =[self.service getVersion:&version];
        dispatch_async(dispatch_get_main_queue(), ^{
            if(ret2 == STATUS_SUCCESS){
                NSString *str = [[NSString alloc]initWithData:version encoding:NSASCIIStringEncoding];
                self.lblVersion.text = [NSString stringWithFormat:@"Version: %@",str];
            }else{
                self.lblVersion.text = [NSString stringWithFormat:@"Version: N/A"];
            }
        });
    });
}

- (void)updateUI:(bool)editing {
    if (editing) {
        [self.idcDetecting startAnimating];
    } else {
        [self.idcDetecting stopAnimating];
    }
    self.switchBeep.enabled = !editing;
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (IBAction)onBtnRefresh:(id)sender {
    [self getBatteryBuzzerStatus];
}

- (IBAction)onSwitchBeep:(id)sender {
    // 操作不能冲突
    if (self.idcDetecting.isAnimating) return;
    
    [self updateUI:YES];
    self.lblStatus.text = @"Setting...";
    __block UInt8 buzzerStatus = (UInt8)self.switchBeep.on;
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_BACKGROUND, 0), ^{
        __block int ret = [self.service setBuzzerStatus:buzzerStatus];
        dispatch_async(dispatch_get_main_queue(), ^{
            if (ret == STATUS_SUCCESS) {
                self.lblStatus.text = @"Success";
            } else {
                self.lblStatus.text = [NSString stringWithFormat:@"Failed: %d", ret];
                [self.switchBeep setOn:!self.switchBeep.on];
            }
            [self updateUI:NO];
        });
    });
}

@end
