//
//  EpcAndTidViewController.m
//  IvrJack.RU01.Demo
//
//  Created by xminnov on 15/4/26.
//  Copyright (c) 2015年 xminnov. All rights reserved.
//

#import "EpcAndTidViewController.h"
#import "IvrJackService.h"
#import "AppDelegate.h"
#import "StrUtils.h"

@interface EpcAndTidViewController ()

@property IvrJackService *service;

@end

@implementation EpcAndTidViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.service = ((AppDelegate *)([UIApplication sharedApplication].delegate)).service;
    self.lblEpc.text = @"";
    self.lblTid.text = @"";
    self.lblStatus.text = @"";
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (IBAction)onBtnRead:(id)sender {
    // 操作不能冲突
    if (self.idcDetecting.isAnimating) return;
    
    NSData *number = [StrUtils convertHexStr:self.tfAccPwd.text];
    if (number == nil) {
        [[[UIAlertView alloc] initWithTitle:@"" message:@"Wrong Password Format" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil] show];
        return;
    }
    
    [self.idcDetecting startAnimating];
    self.lblStatus.text = @"Reading...";
    self.lblEpc.text = @"";
    self.lblTid.text = @"";
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_BACKGROUND, 0), ^{
        NSData *epc;
        NSData *tid;
        __block int ret = [self.service readEpcAndTid:number epc:&epc tid:&tid];
        dispatch_async(dispatch_get_main_queue(), ^{
            [self.idcDetecting stopAnimating];
            if (ret == STATUS_SUCCESS) {
                self.lblStatus.text = @"Success";
                self.lblEpc.text = [StrUtils convertHexBytes:epc spaceBytes:4];
                self.lblTid.text = [StrUtils convertHexBytes:tid spaceBytes:4];
            } else {
                self.lblStatus.text = [NSString stringWithFormat:@"Failed: %d", ret];
            }
        });
    });
}

@end
