//
//  RecordTableViewController.m
//  IvrJack.RU01.Demo
//
//  Created by xminnov on 15/4/25.
//  Copyright (c) 2015年 xminnov. All rights reserved.
//

#import "EpcRecordTableViewController.h"
#import "EpcRecordTableViewCell.h"

@interface EpcRecordTableViewController ()

@property NSMutableArray *records;

@end

@implementation EpcRecordTableViewController

- (instancetype)init
{
    self = [super init];
    if (self) {
        self.records = [NSMutableArray arrayWithCapacity:20];
    }
    return self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
    
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    // Return the number of sections.
//    NSLog(@"number of sections in table view");
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    // Return the number of rows in the section.
//    NSLog(@"number of rows in section: %lu", (unsigned long)self.array.count);
    return self.records.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    EpcRecordTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"record" forIndexPath:indexPath];
    
    EpcRecord *record = [self.records objectAtIndex:indexPath.row];
    [cell setRecord:record];
    [cell.textLabel setNumberOfLines:0];
    
    self.tableView.estimatedRowHeight = 21;
    
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return UITableViewAutomaticDimension;
}

- (NSUInteger)addEpc:(NSString *)epc rssi:(NSString *)rssi{
    int i=0;
    for (; i<self.records.count; i++) {
        EpcRecord *record = [self.records objectAtIndex:i];
        if ([record.epc isEqualToString:epc]) {
            record.rssi = rssi;
            record.count++;
            break;
        }
    }
    if (i == self.records.count) {
        EpcRecord *record = [EpcRecord new];
        record.no = (int)(self.records.count + 1);
        record.epc = epc;
        record.rssi = rssi;
        record.count = 1;
        [self.records addObject:record];
    }
    [self.tableView reloadData];
    return self.records.count;
}

- (void)clearRecords {
    [self.records removeAllObjects];
    [self.tableView reloadData];
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    EpcRecord *record = [self.records objectAtIndex:indexPath.row];
    [self.ru01ViewController accessTagWithEpc:record.epc];
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:@[indexPath] withRowAnimation:UITableViewRowAnimationFade];
    } else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
