//
//  StrUtils.m
//  IvrJack.RU01.Demo
//
//  Created by xminnov on 15/4/26.
//  Copyright (c) 2015年 xminnov. All rights reserved.
//

#import "StrUtils.h"

@implementation StrUtils

+ (NSData *)convertHexStr:(NSString *)str {
    NSString *formatStr = [str stringByReplacingOccurrencesOfString:@" " withString:@""].lowercaseString;
    for (int i=0; i<formatStr.length; i++) {
        unichar c = [formatStr characterAtIndex:i];
        if (!((c >= '0' && c <= '9') || (c >= 'a' && c <= 'f'))) {
            return nil;
        }
    }
    if (formatStr.length % 2 != 0) {
        return nil;
    }
    NSMutableData *data = [NSMutableData data];
    for (int i=0; i<formatStr.length; i+=2) {
        NSString *subStr = [formatStr substringWithRange:NSMakeRange(i, 2)];
        NSScanner *scanner = [NSScanner scannerWithString:subStr];
        unsigned result = 0;
        [scanner scanHexInt:&result];
        [data appendBytes:&result length:1];
    }
    return data;
}

+ (NSString *)convertHexBytes:(NSData *)data spaceBytes:(NSUInteger)spaceBytes {
    NSMutableString *str = [NSMutableString string];
    UInt8 *bytes = (UInt8*)data.bytes;
    for (int i=0; i<data.length; i++) {
        [str appendFormat:@"%02X", bytes[i]];
        if (spaceBytes > 0 && (i + 1) % spaceBytes == 0) {
            [str appendString:@" "];
        }
    }
    return str;
}

+(NSNumber *)convertHexStrToUInt32:(NSString *)str {
    NSString *formatStr = [str stringByReplacingOccurrencesOfString:@" " withString:@""].lowercaseString;
    for (int i=0; i<formatStr.length; i++) {
        unichar c = [formatStr characterAtIndex:i];
        if (!((c >= '0' && c <= '9') || (c >= 'a' && c <= 'z'))) {
            return nil;
        }
    }
    if (formatStr.length != 8) {
        return nil;
    }
    NSScanner *scanner = [NSScanner scannerWithString:formatStr];
    unsigned result = 0;
    [scanner scanHexInt:&result];
    return [NSNumber numberWithUnsignedInt:result];
}

+ (NSNumber *)convertDecStrToUInt8:(NSString *)str {
    for (int i=0; i<str.length; i++) {
        unichar c = [str characterAtIndex:i];
        if (!(c >= '0' && c <= '9')) {
            return nil;
        }
    }
    NSScanner *scanner = [NSScanner scannerWithString:str];
    int result = 0;
    if ([scanner scanInt:&result]) {
        if (result < 0 || result > 255) {
            return nil;
        }
        return [NSNumber numberWithUnsignedChar:(UInt8)result];
    } else {
        return nil;
    }
}

+(NSNumber *)convertDecStrToUInt16:(NSString *)str{
    for (int i = 0; i < str.length; i++) {
        unichar c = [str characterAtIndex:i];
        if(!(c >= '0' && c <= '9')){
            return nil;
        }
    }
    NSScanner *scanner = [NSScanner scannerWithString:str];
    int result = 0;
    if([scanner scanInt:&result]) {
        if(result < 0 || result > 65535){
            return nil;
        }
        return [NSNumber numberWithUnsignedChar:(UInt16)result];
    }else{
        return nil;
    }
}


@end
