//
//  TagKillViewController.m
//  IvrJack.RU01.Demo
//
//  Created by xminnov on 15/4/26.
//  Copyright (c) 2015年 xminnov. All rights reserved.
//

#import "TagKillViewController.h"
#import "IvrJackService.h"
#import "AppDelegate.h"
#import "StrUtils.h"
#import "RU01ViewController.h"

@interface TagKillViewController ()

@property IvrJackService *service;

@end

@implementation TagKillViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.service = ((AppDelegate *)([UIApplication sharedApplication].delegate)).service;
    RU01ViewController *ru01ViewController = (RU01ViewController *)([self.navigationController.viewControllers objectAtIndex:0]);
    self.lblEpc.text = ru01ViewController.selectedEpc;
    self.lblStatus.text = @"";
    self.tfAccPwd.delegate = self;
    self.tfKillPwd.delegate = self;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (IBAction)onBtnKill:(id)sender {
    // 操作不能冲突
    if (self.idcDetecting.isAnimating) return;
    
    @try {
        NSData *epc = [StrUtils convertHexStr:self.lblEpc.text];
        NSData *accPwd = [StrUtils convertHexStr:self.tfAccPwd.text];
        if (!accPwd) {
            @throw [NSException exceptionWithName:@"" reason:@"Wrong access password format" userInfo:nil];
        }
        NSData *killPwd = [StrUtils convertHexStr:self.tfKillPwd.text];
        if (!killPwd) {
            @throw [NSException exceptionWithName:@"" reason:@"Wrong kill password format" userInfo:nil];
        }
        
        [self.idcDetecting startAnimating];
        self.lblStatus.text = @"Kill...";
        self.tfKillPwd.enabled = NO;
        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_BACKGROUND, 0), ^{
            NSString *operate = @"Select Tag";
            __block int ret = [self.service selectTag:accPwd epc:epc];
            if (ret == 0) {
                operate = @"Kill Tag";
                ret = [self.service killTag:killPwd];
            }
            dispatch_async(dispatch_get_main_queue(), ^{
                if (ret == 0) {
                    self.lblStatus.text = @"Success";
                } else {
                    self.lblStatus.text = [NSString stringWithFormat:@"Failed: %d", ret];
                }
                [self.idcDetecting stopAnimating];
                self.tfKillPwd.enabled = YES;
            });
        });
    }
    @catch (NSException *e) {
        [[[UIAlertView alloc] initWithTitle:@"" message:e.reason delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil] show];
    }
}
@end
