//
//  TagLockViewController.m
//  IvrJack.RU01.Demo
//
//  Created by xminnov on 15/4/26.
//  Copyright (c) 2015年 xminnov. All rights reserved.
//

#import "TagLockViewController.h"
#import "IvrJackService.h"
#import "AppDelegate.h"
#import "StrUtils.h"
#import "RU01ViewController.h"

@interface TagLockViewController ()

@property IvrJackService *service;

@end

@implementation TagLockViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.service = ((AppDelegate *)([UIApplication sharedApplication].delegate)).service;
    RU01ViewController *ru01ViewController = (RU01ViewController *)([self.navigationController.viewControllers objectAtIndex:0]);
    self.lblEpc.text = ru01ViewController.selectedEpc;
    self.lblStatus.text = @"";
    self.tfAccPwd.delegate = self;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (IBAction)onBtnLock:(id)sender {
    // 操作不能冲突
    if (self.idcDetecting.isAnimating) return;
    
    @try {
        NSData *epc = [StrUtils convertHexStr:self.lblEpc.text];
        NSData *password = [StrUtils convertHexStr:self.tfAccPwd.text];
        if (!password) {
            @throw [NSException exceptionWithName:@"" reason:@"Wrong access password format" userInfo:nil];
        }
        __block UInt8 lockObject = self.scLockObject.selectedSegmentIndex;
        __block UInt8 lockAction = self.scLockAction.selectedSegmentIndex;
        
        [self.idcDetecting startAnimating];
        self.lblStatus.text = @"Locking...";
        self.tfAccPwd.enabled = NO;
        self.scLockObject.enabled = NO;
        self.scLockAction.enabled = NO;
        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_BACKGROUND, 0), ^{
            NSString *operate = @"Select Tag";
            __block int ret = [self.service selectTag:password epc:epc];
            if (ret == 0) {
                operate = @"Lock Tag";
                ret = [self.service lockTag:password mask:lockObject action:lockAction];
            }
            dispatch_async(dispatch_get_main_queue(), ^{
                if (ret == 0) {
                    self.lblStatus.text = @"Success";
                } else {
                    self.lblStatus.text = [NSString stringWithFormat:@"%@ Failed: %d", operate, ret];
                }
                [self.idcDetecting stopAnimating];
                self.tfAccPwd.enabled = YES;
                self.scLockObject.enabled = YES;
                self.scLockAction.enabled = YES;
            });
        });
    }
    @catch (NSException *e) {
        [[[UIAlertView alloc] initWithTitle:@"" message:e.reason delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil] show];
    }
}

@end
