//
//  TagWriteViewController.m
//  IvrJack.RU01.Demo
//
//  Created by xminnov on 15/4/26.
//  Copyright (c) 2015年 xminnov. All rights reserved.
//

#import "TagWriteViewController.h"
#import "IvrJackService.h"
#import "AppDelegate.h"
#import "StrUtils.h"
#import "RU01ViewController.h"

@interface TagWriteViewController ()

@property IvrJackService *service;

@end

@implementation TagWriteViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.service = ((AppDelegate *)([UIApplication sharedApplication].delegate)).service;
    RU01ViewController *ru01ViewController = (RU01ViewController *)([self.navigationController.viewControllers objectAtIndex:0]);
    self.lblEpc.text = ru01ViewController.selectedEpc;
    self.lblStatus.text = @"";
    self.tfAccPwd.delegate = self;
    self.tfStartAddress.delegate = self;
    self.tfLength.delegate = self;
    self.tvData.delegate = self;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (IBAction)onBtnWrite:(id)sender {
    // 操作不能冲突
    if (self.idcDetecting.isAnimating) return;
    
    @try {
        NSData *epc = [StrUtils convertHexStr:self.lblEpc.text];
        NSData *password = [StrUtils convertHexStr:self.tfAccPwd.text];
        if (!password) {
            @throw [NSException exceptionWithName:@"" reason:@"Wrong access password format" userInfo:nil];
        }
        NSNumber *address = [StrUtils convertDecStrToUInt16:self.tfStartAddress.text];
        if (!address) {
            @throw [NSException exceptionWithName:@"" reason:@"Wrong start address format" userInfo:nil];
        }
        NSNumber *length = [StrUtils convertDecStrToUInt8:self.tfLength.text];
        if (!length) {
            @throw [NSException exceptionWithName:@"" reason:@"Wrong length format" userInfo:nil];
        }
        NSData *data = [StrUtils convertHexStr:self.tvData.text];
        if (!data) {
            @throw [NSException exceptionWithName:@"" reason:@"Wrong data format" userInfo:nil];
        }
        if (data.length != length.unsignedCharValue * 2) {
            @throw [NSException exceptionWithName:@"" reason:@"Wrong data length" userInfo:nil];
        }
        __block UInt8 memoryBlock = (UInt8)self.scMemoryBlock.selectedSegmentIndex;
        
        [self.idcDetecting startAnimating];
        self.lblStatus.text = @"Writing...";
        self.tfAccPwd.enabled = NO;
        self.tfStartAddress.enabled = NO;
        self.scMemoryBlock.enabled = NO;
        self.tfLength.enabled = NO;
        self.tvData.editable = NO;
        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_BACKGROUND, 0), ^{
            NSString *operate = @"Select Tag";
            __block int ret = [self.service selectTag:password epc:epc];
            if (ret == 0) {
                operate = @"Write Tag";
                ret = [self.service writeTag:memoryBlock address:address.unsignedCharValue count:length.unsignedCharValue data:data];
            }
            dispatch_async(dispatch_get_main_queue(), ^{
                if (ret == 0) {
                    self.lblStatus.text = @"Success";
                    self.tvData.text = [StrUtils convertHexBytes:data spaceBytes:4];
                } else {
                    self.lblStatus.text = [NSString stringWithFormat:@"%@ Failed: %d", operate, ret];
                }
                [self.idcDetecting stopAnimating];
                self.tfAccPwd.enabled = YES;
                self.tfStartAddress.enabled = YES;
                self.scMemoryBlock.enabled = YES;
                self.tfLength.enabled = YES;
                self.tvData.editable = YES;
            });
        });
        
    }
    @catch (NSException *e) {
        [[[UIAlertView alloc] initWithTitle:@"" message:e.reason delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil] show];
    }
}
@end
