//
//  UIViewControllerWithTextEditor.m
//  IvrJack.RU01.Demo
//
//  Created by xminnov on 15/4/29.
//  Copyright (c) 2015年 xminnov. All rights reserved.
//

#import "UIViewControllerWithTextEditor.h"

@implementation UIViewControllerWithTextEditor

- (void)viewDidLoad {
    [super viewDidLoad];
    // 监听所有输入框控件
//    [self doSubViews:self.view];
}

//- (void)doSubViews:(UIView *)view {
//    NSLog(@"doSubViews: %@", view);
//    NSArray *subViews = view.subviews;
//    for (int i=0; i<subViews.count; i++) {
//        UIView *subView = [subViews objectAtIndex:i];
//        if ([subView isKindOfClass:[UITextField class]]) {
//            NSLog(@"UITextField delegate");
//            ((UITextField *)subView).delegate = self;
//        }
//        if ([subView isKindOfClass:[UITextView class]]) {
//            NSLog(@"UITextView delegate");
//            UITextView *textView = (UITextView *)subView;
//            textView.delegate = self;
//            textView.layer.borderWidth = 0.5f;
//            textView.layer.borderColor = [UIColor lightGrayColor].CGColor;
//            textView.layer.cornerRadius = 5;
//        }
//        [self doSubViews:subView];
//    }
//}

#pragma mark - 输入框编辑事件

- (BOOL)textFieldShouldReturn:(UITextField *)textField {
    [textField resignFirstResponder];
    return YES;
}

- (void)textFieldDidBeginEditing:(UITextField *)textField {
    [self adjustTextEditorPosition:textField];
}

- (void)textFieldDidEndEditing:(UITextField *)textField {
    [self restoreTextEditorPosition];
}

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range replacementText:(NSString *)text {
    if ([text isEqualToString:@"\n"]) {
        [textView resignFirstResponder];
        return NO;
    }
    return YES;
}

- (void)textViewDidBeginEditing:(UITextView *)textView {
    [self adjustTextEditorPosition:textView];
}

- (void)textViewDidEndEditing:(UITextView *)textView {
    [self restoreTextEditorPosition];
}

#pragma mark - 调整布局位置以适应键盘

- (void)adjustTextEditorPosition:(UIView *)view {
    float offset = -216.0f; // 键盘高度216
    // 计算控件与键盘距离
    while (view != self.view && view != nil) {
        UIView *superView = view.superview;
        offset += (superView.frame.size.height - view.frame.size.height - view.frame.origin.y);
        view = superView;
    }
    // 如果被键盘覆盖，布局整体上移
    if (offset < 0) {
        NSTimeInterval animationDuration = 0.30f;
        [UIView beginAnimations:@"ResizeForKeyboard" context:nil];
        [UIView setAnimationDuration:animationDuration];
        self.view.frame = CGRectMake(0.0f, offset, self.view.frame.size.width, self.view.frame.size.height);
        [UIView commitAnimations];
    }
}

- (void)restoreTextEditorPosition {
    if (self.view.frame.origin.y != 0) {
        NSTimeInterval animationDuration = 0.30f;
        [UIView beginAnimations:@"ResizeForKeyboard" context:nil];
        [UIView setAnimationDuration:animationDuration];
        self.view.frame = CGRectMake(0.0f, 0, self.view.frame.size.width, self.view.frame.size.height);
        [UIView commitAnimations];
    }
}

@end
